# all files / diagram-js/lib/features/editor-actions/ EditorActions.js

64.1% Statements 50/78
62.16% Branches 23/37
40% Functions 8/20
64.1% Lines 50/78

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    159
    160
    161
    162
    163
    164
    165
    166
    167
    168
    169
    170
    171
    172
    173
    174
    175
    176
    177
    178
    179
    180
    181
    182
    183
    184
    185
    186
    187
    188
    189
    190
    191
    192
    193
    194
    195
    196
    197
    198
    199
    200
    201
    202
    203
    204
    205
    206
    207
    208
    209
    210
    211
    212
    213
    214
    215
    216
    217
    218
    219
    220
    221
    222
    223
    224
    225
    226
    227
    228
    229
    230
    231
    232
    233
    234
    235
    236
    237
    238
    239
    240
    241
    242
    243
    244
    245
    246
    247
    248
    249
    250
    251
    252
    253
    254
    255
    256
    257
    258
    259

    1×
    1×

    70×

    70×

    70×

    70×

    70×

    1×

    1×

    70×
    70×
    70×
    70×
    70×
    70×
    70×
    70×
    70×

    70×
    69×

    69×

    70×
    69×

    70×
    69×

    70×
    54×

    70×
    70×

    70×
    69×

    70×
    54×

    70×
    53×

    1×
    17×

    17×

    1×
    576×

    576×
    576×

    1×
    1289×

    1289×

    1×

    1×
    3×

    1×
    2287×

     import {
      forEach,
      isArray
    } from 'min-dash';

    var NOT_REGISTERED_ERROR = 'is not a registered action',
        IS_REGISTERED_ERROR = 'is already registered';

    /**
     * An interface that provides access to modeling actions by decoupling
     * the one who requests the action to be triggered and the trigger itself.
     *
     * It's possible to add new actions by registering them with ´registerAction´
     * and likewise unregister existing ones with ´unregisterAction´.
     *
     *
     * ## Life-Cycle and configuration
     *
     * The editor actions will wait for diagram initialization before
     * registering default actions _and_ firing an `editorActions.init` event.
     *
     * Interested parties may listen to the `editorActions.init` event with
     * low priority to check, which actions got registered. Other components
     * may use the event to register their own actions via `registerAction`.
     *
     * @param {EventBus} eventBus
     * @param {Injector} injector
     */
    export default function EditorActions(eventBus, injector) {

      // initialize actions
      this._actions = {};

      var self = this;

      eventBus.on('diagram.init', function() {

        // all diagram modules got loaded; check which ones
        // are available and register the respective default actions
        self._registerDefaultActions(injector);

        // ask interested parties to register available editor
        // actions on diagram initialization
        eventBus.fire('editorActions.init', {
          editorActions: self
        });
      });

    }

    EditorActions.$inject = [
      'eventBus',
      'injector'
    ];

    /**
     * Register default actions.
     *
     * @param {Injector} injector
     */
    EditorActions.prototype._registerDefaultActions = function(injector) {

      // (1) retrieve optional components to integrate with

      var commandStack = injector.get('commandStack', false);
      var modeling = injector.get('modeling', false);
      var selection = injector.get('selection', false);
      var zoomScroll = injector.get('zoomScroll', false);
      var copyPaste = injector.get('copyPaste', false);
      var canvas = injector.get('canvas', false);
      var rules = injector.get('rules', false);
      var keyboardMove = injector.get('keyboardMove', false);
      var keyboardMoveSelection = injector.get('keyboardMoveSelection', false);

      // (2) check components and register actions

      if (commandStack) {
        this.register('undo', function() {
          commandStack.undo();
        });

        this.register('redo', function() {
          commandStack.redo();
        });
      }

      if (copyPaste && selection) {
        this.register('copy', function() {
          var selectedElements = selection.get();

          copyPaste.copy(selectedElements);
        });
      }

      if (copyPaste) {
        this.register('paste', function() {
          copyPaste.paste();
        });
      }

      if (zoomScroll) {
        this.register('stepZoom', function(opts) {
          zoomScroll.stepZoom(opts.value);
        });
      }

      Eif (canvas) {
        this.register('zoom', function(opts) {
          canvas.zoom(opts.value);
        });
      }

      if (modeling && selection && rules) {
        this.register('removeSelection', function() {

          var selectedElements = selection.get();

          if (!selectedElements.length) {
            return;
          }

          var allowed = rules.allowed('elements.delete', { elements: selectedElements }),
              removableElements;

          if (allowed === false) {
            return;
          }
          else if (isArray(allowed)) {
            removableElements = allowed;
          }
          else {
            removableElements = selectedElements;
          }

          if (removableElements.length) {
            modeling.removeElements(removableElements.slice());
          }
        });
      }

      if (keyboardMove) {
        this.register('moveCanvas', function(opts) {
          keyboardMove.moveCanvas(opts);
        });
      }

      if (keyboardMoveSelection) {
        this.register('moveSelection', function(opts) {
          keyboardMoveSelection.moveSelection(opts.direction, opts.accelerated);
        });
      }

    };

    /**
     * Triggers a registered action
     *
     * @param  {String} action
     * @param  {Object} opts
     *
     * @return {Unknown} Returns what the registered listener returns
     */
    EditorActions.prototype.trigger = function(action, opts) {
      Iif (!this._actions[action]) {
        throw error(action, NOT_REGISTERED_ERROR);
      }

      return this._actions[action](opts);
    };

    /**
     * Registers a collections of actions.
     * The key of the object will be the name of the action.
     *
     * @example
     * ´´´
     * var actions = {
     *   spaceTool: function() {
     *     spaceTool.activateSelection();
     *   },
     *   lassoTool: function() {
     *     lassoTool.activateSelection();
     *   }
     * ];
     *
     * editorActions.register(actions);
     *
     * editorActions.isRegistered('spaceTool'); // true
     * ´´´
     *
     * @param  {Object} actions
     */
    EditorActions.prototype.register = function(actions, listener) {
      var self = this;

      Eif (typeof actions === 'string') {
        return this._registerAction(actions, listener);
      }

      forEach(actions, function(listener, action) {
        self._registerAction(action, listener);
      });
    };

    /**
     * Registers a listener to an action key
     *
     * @param  {String} action
     * @param  {Function} listener
     */
    EditorActions.prototype._registerAction = function(action, listener) {
      Iif (this.isRegistered(action)) {
        throw error(action, IS_REGISTERED_ERROR);
      }

      this._actions[action] = listener;
    };

    /**
     * Unregister an existing action
     *
     * @param {String} action
     */
    EditorActions.prototype.unregister = function(action) {
      if (!this.isRegistered(action)) {
        throw error(action, NOT_REGISTERED_ERROR);
      }

      this._actions[action] = undefined;
    };

    /**
     * Returns the number of actions that are currently registered
     *
     * @return {Number}
     */
    EditorActions.prototype.getActions = function() {
      return Object.keys(this._actions);
    };

    /**
     * Checks wether the given action is registered
     *
     * @param {String} action
     *
     * @return {Boolean}
     */
    EditorActions.prototype.isRegistered = function(action) {
      return !!this._actions[action];
    };

    function error(action, message) {
      return new Error(action + ' ' + message);
    }